//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  LimeGreen
#property indicator_color2  Green
#property indicator_color3  OrangeRed
#property indicator_color4  Crimson
#property indicator_color5  LimeGreen
#property indicator_color6  Green
#property indicator_color7  OrangeRed
#property indicator_color8  Crimson
#property indicator_minimum 0
#property indicator_maximum 3

//
//
//
//
//

extern string TimeFrame1            = "Current time frame";
extern string TimeFrame2            = "next1";
extern bool   UseRsi                = false;   
extern double Length                = 10;  
extern double Signal                = 5;  
extern double Smooth                = 5; 
extern int    Price                 = 0; 
extern int    MaMethod              = 5; 
extern bool   NewSignals            = false;
extern string UniqueID              = "2 Time frames asa";
extern int    LinesWidth            =  0;
extern color  LabelsColor           = DarkGray;
extern int    LabelsHorizontalShift = 5;
extern double LabelsVerticalShift   = 1.2;
extern string MaMethods   = "";
extern string __0         = "SMA";
extern string __1         = "EMA";
extern string __2         = "Double smoothed EMA";
extern string __3         = "Double EMA (DEMA)";
extern string __4         = "Triple EMA (TEMA)";
extern string __5         = "Smoothed MA";
extern string __6         = "Linear weighted MA";
extern string __7         = "Parabolic weighted MA";
extern string __8         = "Alexander MA";
extern string __9         = "Volume weghted MA";
extern string __10        = "Hull MA";
extern string __11        = "Triangular MA";
extern string __12        = "Sine weighted MA";
extern string __13        = "Linear regression";
extern string __14        = "IE/2";
extern string __15        = "NonLag MA";
extern string __16        = "Zero lag EMA";
extern string __17        = "Leader EMA";
extern string __18        = "Super smoother";
extern string __19        = "Smoother";

//
//
//
//
//

double Dot11[];
double Dot12[];
double Dot13[];
double Dot14[];
double Dot21[];
double Dot22[];
double Dot23[];
double Dot24[];

int    timeFrames[2];
bool   returnBars;
bool   calculateValue;
string indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Dot11);
   SetIndexBuffer(1,Dot12);
   SetIndexBuffer(2,Dot13);
   SetIndexBuffer(3,Dot14);
   SetIndexBuffer(4,Dot21);
   SetIndexBuffer(5,Dot22);
   SetIndexBuffer(6,Dot23);
   SetIndexBuffer(7,Dot24);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame1=="returnBars");     if (returnBars)     return(0);
      
      //
      //
      //
      //
      //
      
      for (int i=0; i<8; i++) 
      {
         SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth); SetIndexArrow(i,110); 
      }
      timeFrames[0] = stringToTimeFrame(TimeFrame1);
      timeFrames[1] = stringToTimeFrame(TimeFrame2);
      IndicatorShortName(UniqueID);
   return(0);
}
int deinit()
{
   for (int t=0; t<4; t++) ObjectDelete(UniqueID+t);
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)     { Dot11[0] = limit+1;  return(0); }

         if (timeFrames[0] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,"returnBars",0,0)*timeFrames[0]/Period()));
         if (timeFrames[1] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[1],indicatorFileName,"returnBars",0,0)*timeFrames[1]/Period()));

         //
         //
         //
         //
         //
         
         bool initialized = false;
         if (!initialized)
         {
            initialized = true;
            int window = WindowFind(UniqueID);
            for (int t=0; t<2; t++)
            {
               string label = timeFrameToString(timeFrames[t]);
               ObjectCreate(UniqueID+t,OBJ_TEXT,window,0,0);
                  ObjectSet(UniqueID+t,OBJPROP_COLOR,LabelsColor);
                  ObjectSet(UniqueID+t,OBJPROP_PRICE1,t+LabelsVerticalShift);
                  ObjectSetText(UniqueID+t,label,8,"Arial");
            }               
         }
         for (t=0; t<2; t++) ObjectSet(UniqueID+t,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

   //
   //
   //
   //
   //
    
   for(int i = limit; i >= 0; i--)
   {
      for (int k=0; k<4; k++)
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
               switch (k)
               {
                  case 0 : 
                        Dot11[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,4,y); if (Dot11[i]!=EMPTY_VALUE) Dot11[i] = 1;
                        Dot12[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,5,y); if (Dot12[i]!=EMPTY_VALUE) Dot12[i] = 1;
                        Dot13[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,6,y); if (Dot13[i]!=EMPTY_VALUE) Dot13[i] = 1;
                        Dot14[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,7,y); if (Dot14[i]!=EMPTY_VALUE) Dot14[i] = 1;
                  case 1 : 
                        Dot21[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,4,y); if (Dot21[i]!=EMPTY_VALUE) Dot21[i] = 2;
                        Dot22[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,5,y); if (Dot22[i]!=EMPTY_VALUE) Dot22[i] = 2;
                        Dot23[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,6,y); if (Dot23[i]!=EMPTY_VALUE) Dot23[i] = 2;
                        Dot24[i] = iCustom(NULL,timeFrames[k],"AbsoluteStrength of Averages_mtf 2.02","",UseRsi,Length,Signal,Smooth,Price,MaMethod,NewSignals,7,y); if (Dot24[i]!=EMPTY_VALUE) Dot24[i] = 2;
               }
      }
   }
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }

      //
      //
      //
      //
      //
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}